[CCode (lower_case_cprefix = "sql_", cheader_filename = "libsql/sql_parser.h")]
namespace SQL {
	[CCode (cprefix = "SQL_", cname = "sql_statement_type")]
	public enum StatementType {
		[CCode (cname = "select")]
		SELECT,
		[CCode (cname = "insert")]
		INSERT,
		[CCode (cname = "delete")]
		DELETE,
		[CCode (cname = "update")]
		UPDATE
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_statement")]
	public class Statement {
		public StatementType type;
		public string full_query;
		public void* statement;
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_select_statement")]
	public class SelectStatement {
		public int distinct;
		public GLib.List<SQL.Field> fields;
		public GLib.List<SQL.Table> table;
		public SQL.Where where;
		public GLib.List<SQL.OrderField> order;
		public GLib.List group;
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_where")]
	public class Where {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_field")]
	public class Field {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_order_field")]
	public class OrderField {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_table")]
	public class Table {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_delete_statement")]
	public class DeleteStatement {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_insert_statement")]
	public class InsertStatement {
		// TODO
	}

	[Compact]
	[CCode (free_function = "sql_destroy", cname = "sql_update_statement")]
	public class UpdateStatement {
		// TODO
	}
}
